#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dominoProcAsto.tcl,v 1.1 2004/09/06 14:47:14 cguirao Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# fsogni  26/01/98  created
#
#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc dominoInitX {} {
    global gvar env cv daCV argc argv 


    #if {$argc == 0} {puts "Usage: dataSubscriber <file type>"; exit }
    #set gvar(fileType) [lindex $argv 0]	
   
    #Set ID to ASTO temporarily
    #set gvar(dhs-subscriberID) ASTO
    set daCV $cv
    
    #Check the existance of system variables
    if {![info exists env(DHS_LOG)] || ![file isdir $env(DHS_LOG)]} { Info "DHS_LOG variable not set\n or directory does not exist."; exit }
    if {![info exists env(DFS_BACKLOG)] || ![file isdir $env(DFS_BACKLOG)]} { Info "DFS_BACKLOG variable not set\n or directory does not exist."; exit }
    if {![info exists env(DHS_HOST)]} { Info "DHS_HOST variable not set"; exit }
    if {![info exists env(HOST)]} {Info "HOST variable not set"; exit }
    if {![info exists env(BAD_DIR)] || ![file isdir $env(BAD_DIR)]} { Info "BAD_DIR variable not set\n or directory does not exist."; exit }
    if {![info exists env(HOME)] || ![file isdir $env(HOME)] } { Info "HOME variable not set\n or directory does not exist."; exit }
    if {![info exists gvar(fileType)]} {puts "You didn't specify a file type"
	explain}
	if {![info exists gvar(archID)]} {puts "You didn't specify a unique ID"
	explain}
    set gvar(dhs-subscriberID) "ASTO-$gvar(archID)-$gvar(fileType)::$env(HOST)::$gvar(archID)"
    
	# Set some important flags
	package require SeqOslx
	set gvar(modifyFlag)             0
	set gvar(fileSaved)              0
	set gvar(clearFlag)              1
	set gvar(startFlag)              0
	set gvar(useSeqOslxCmd)          1
	set gvar(useCCS)                 0
	set gvar(logErrorsOnStderr)      1
	set gvar(filesProcessed)         0
	set gvar(filesArrived)           0
	#$daCV.dominoShowLogWdg             disable
	set gvar(fromToLabel)            ""
	set gvar(cancelLoop)             0
	set gvar(alreadyRunning)         0
	set gvar(astoStatusFlag)         0
	set gvar(cancelDeathLoop)        0
	set gvar(cancelLifeLoop)         0
	set gvar(loopLifeTime)           10000
	
    # Capture the window manager delete window action and override the
    # window manager's default action.
    set _top_level [winfo toplevel $daCV]
    wm protocol $_top_level WM_DELETE_WINDOW "bell"
    
    #Trap signals
    signal trap {INT QUIT TERM} {Info "Please use Quit to exit from the application."}
    signal trap {CONT} "wm deiconify ."

 
    #read config file
    dominoDefaults
    
    #clean directories and reset counters
    #htReset

    #Set number of files queued
    if {[catch {set gvar(filesQueued) [llength [glob $env(DHS_LOG)/.*$gvar(dhs-subscriberID)*.bulk]]}]} {set gvar(filesQueued) 0}

    #Here we need to kinds of counters, an absolute counter
    #(.counter-$gvar(dhs-subscriberID).tmp) and a partial counter (.counter-par-$gvar(dhs-subscriberID).tmp)
    #The first one is used to compute the processed files 
    #(gzipped and moved) the other one is used to count
    #the new arrivals

    #Set number of files processed
    if {[file exists $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp]} {
    set count [open $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp r]
    gets $count gvar(filesProcessed) 
    close $count
    } else {set count [open $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp w]
	puts $count "0"
	close $count 
	catch { chmod g+w $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp }
    }
    
    #Set number of files arrived
    if {[file exists $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp]} {
    set countpar [open $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp r]
    gets $countpar gvar(filesArrived)
    close $countpar
    } else { set countpar [open $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp w]
	puts $countpar "0"
	close $countpar 
	catch { chmod g+w $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp }
}	

    #Reset number of files expected
    #SOG rember to change the file name according to the file type
    $daCV.dataSubscriberAstoBarchartWdg configure -barColor blue
    if {[file exists $env(DHS_LOG)/.expected-$gvar(dhs-subscriberID).tmp]} {file delete $env(DHS_LOG)/.expected-$gvar(dhs-subscriberID).tmp}
    set gvar(expected) 0
    set gvar(perc) 0
    

    # Set the icon to be used    
    set myTop [winfo toplevel $daCV]
    wm iconbitmap $myTop "@$env(INTROOT)/bitmaps/get-file1.xbm"
    
    #Bindings
    bind $daCV.dominoNttWdg.frame.uifBitmap  <Button-1>  {setNormal}


    #Load the dictionaries (actually I don't need dictionaries)
    #set gvar(dic) $env(INS_ROOT)/SYSTEM/Dictionary/ALL 
    #dominoSetDictionary $gvar(dic)

    #Start the check loop
    #dominoLoop 1000 checkArrivals
    
    #if {[file exists $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} {
    #	startState 
    #    } else { stopState }
    
    if {[file readable $env(DHS_LOG)/dataSubscriberAsto-$gvar(dhs-subscriberID).pid]} {
	set pid [read_file $env(DHS_LOG)/dataSubscriberAsto-$gvar(dhs-subscriberID).pid]
	if {![catch {exec kill -26 $pid} result]} {Info "There is already a dataSubscriberAsto running, connected to $env(DHS_HOST) and retrieving $gvar(fileType)files."
	    exit }
    }


    if {[file exists $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} { 
		Debug "dhsSubscribe is already running" 2
		#if {$gvar(alreadyRunning-RED) == 0} {$mainCV.dominoStartWdgRED enable}
		dominoGetInfo
		set gvar(alreadyRunning) 1
		set gvar(goFlag) 0
		set gvar(countPid) 0
		dominoLoop 1000 "checkPid"
	#vwait gvar(goFlag)
    } else {
	
	Debug "$env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid does not exist, RAW not running" 2
	stopState
	$daCV.dominoStartWdg disable
	#Check date if inserted and if another dhsSubscriber is running
	dominoAstoCheckEnv
    }
    
    #Create a file in the format containing the pid.
    if {[catch {write_file $env(DHS_LOG)/dataSubscriberAsto-$gvar(dhs-subscriberID).pid [id process]}]} {Info "I cannot create the pid file under $env(DHS_LOG)."; exit }
}

proc dominoGetInfo {} {
    global gvar env daCV
   
    if {[file exists $env(DHS_LOG)/DhsSubscribeInfo-$env(HOST)-$gvar(dhs-subscriberID)]} {
	ScanConfigFile  $env(DHS_LOG)/DhsSubscribeInfo-$env(HOST)-$gvar(dhs-subscriberID) gvar
    } else { Info "I cannot open  $env(DHS_LOG)/DhsSubscribeInfo-$env(HOST)-$gvar(dhs-subscriberID)" ; return 1}

    if {$gvar(dominoTo) != ""} {
	set gvar(fromToLabel) "$gvar(dominoFrom) to $gvar(dominoTo)"
    } else {set gvar(fromToLabel) "From $gvar(dominoFrom)"}
    
    $daCV.dataSubscriberAstoBarchartWdg configure -label "files from $env(DHS_HOST)"

    Debug "dominoFrom: $gvar(dominoFrom)" 1  
    Debug "dominoTo: $gvar(dominoTo)"      1
   
    if {[catch {set file [open $env(DHS_LOG)/.expected-$gvar(dhs-subscriberID).tmp w]}]} { return 1
    } else { puts $file $gvar(expected); close $file}
}

proc writeSchemaInfo {} {
    global gvar env

    if {[catch {set infofile [open $env(DHS_LOG)/DhsSubscribeInfo-$env(HOST)-$gvar(dhs-subscriberID) w]}]} { Info "I cannot open Info file." ; return 1}

    puts $infofile "dominoFrom: $gvar(dominoFrom)"      
    puts $infofile "dominoTo: $gvar(dominoTo)"      
    if {[info exists gvar(expected)]} {
	puts $infofile "expected: $gvar(expected)"
    } else {puts $infofile "expected: "}
        close $infofile
    return 0
}


#It is not used for the moment
proc htReset {} {
    global env
    
    #cleaning subdirectories
    #catch {file delete [glob -nocomplain $env(BAD_DIR)/*]}
    #catch {file delete [glob -nocomplai $env(DFS_BACKLOG)/*]}
    
    #Reset the file counter
    set count [open $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp w]
    puts $count "0"
    close $count
    catch { chmod g+w $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp }
}

proc Start {} {
    global gvar env daCV


    #Patch of desperation
    set gvar(cancelLoop) 0


    #Look for files left under DHS_DATA
    processLeftovers 
    
    #Reset counter of the processedfiles
    set count [open $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp w]
    puts $count "0"
    close $count
    catch { chmod g+w $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp } 
    set gvar(filesProcessed) 0
    
    #Reset counter of the arrived files
    set countpar [open $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp w]
    puts $countpar "0"
    close $countpar
    catch { chmod g+w $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp }
    set gvar(filesArrived) 0
	set Command "dhsSubscribeControl start asto -id $gvar(dhs-subscriberID) -filetype $gvar(fileType) -backlogdir $env(DFS_BACKLOG) -run \"postArrival %s $gvar(dhs-subscriberID)\" "
    
    #Here I put the dhs-command
    
    if {$gvar(dominoFrom) != ""} {append Command " -backsince $gvar(dominoFrom)"
	set gvar(fromToLabel) "From $gvar(dominoFrom)"
	$daCV.dataSubscriberAstoBarchartWdg configure -barColor grey
	set gvar(perc) 100
	if {[writeSchemaInfo]} { return }
    }
    
    if {$gvar(dominoTo) != ""} {append Command " -backto $gvar(dominoTo)"
	set gvar(fromToLabel) "$gvar(dominoFrom) to $gvar(dominoTo)" 
	$daCV.dataSubscriberAstoBarchartWdg config -barColor blue
	set gvar(perc) 0}
    
    Debug "Execute: $Command" 1
    #SOG I promise to understand how to check the exit code
    eval exec $Command &
    #after 3000 startState
    
    $daCV.dataSubscriberAstoBarchartWdg configure -label "dhsSubscribe is starting."
    $daCV.dominoStartWdg disable
    $daCV.dominoConfigWdg disable

    #I used these commands to wait dhsSubscribe to come up.
    set gvar(goFlag) 0
    set gvar(countPid) 0
    dominoLoop 1000 "checkPid"
    vwait gvar(goFlag)
}


#Wait for the DhsSubscribe to be created.
proc checkPid {} {
    global gvar env daCV

    Debug "Waiting for dhsSubscribe to come up" 3
    if {$gvar(countPid) == 30} {
	set gvar(cancelLoop) 1
	set gvar(goFlag) 1
	Info "dhsSubscribe  doesn't come up"
	$daCV.dataSubscriberAstoBarchartWdg configure -label "Start dhsSubscribe failed"
	stopState
    } else {
	if {[file exists $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} {
	    if {[catch {exec ps -p [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} result]} { 
		catch {file delete $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid}
		set gvar(cancelLoop) 1
		stopState
		set gvar(goFlag) 1
		Info "dhsSubscribe  doesn't come up.\nPid created, but not valid."
		$daCV.dataSubscriberAstoBarchartWdg configure -label "Start dhsSubscribe failed"
		$daCV.dominoConfigWdg enable
		return 1
	    }
	    set gvar(cancelLoop) 1
	    startState
		set gvar(alreadyRunning) 1
	    set gvar(goFlag) 1
	    after 5000 "dominoLoop 1000 \"checkArrivals\"" 
		after 5000 "dominoLifeLoop  \"checkLifeLoop\""
	} else { incr gvar(countPid) +1 }
    }
}


#Loop to check if the processes are running.
proc checkLifeLoop {} {
	global gvar env

	case $gvar(lifeState) {
		"alive"     {checkLife }
		"dhsDied"   {after 3000 checkWatchdog }
		"reviving"  {checkRevive }
		"dead"      { return }
		*           {Debug  "Error condition in lifeloop: $gvar(lifeState)" 1}
	} 
}

#Check if the dhsSubscribe process is alive.
proc checkLife {} {
	global gvar env daCV
		
	if {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} result]} { 

		#dhsSubscribe died
		Debug "dhsSubscribe died" 1
		#$daCV.dataSubscriberAstoBarchartWdg configure -background red
		Alarm
		$daCV.dataSubscriberAstoBarchartWdg configure -label "Process died.Wait..."
		set gvar(lifeState) "dhsDied"
		set gvar(loopLifeTime) 3000
	} 		
}

#Check if the watchdog process is alive.
proc checkWatchdog {} {
	global gvar env daCV
	
	if {$gvar(lifeState) == "dead" } { return }
	
	if {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID)-watchdog.pid]} result] } { 
		#also watchdog died.
		Alarm
		Debug "watchdog died: $result" 1
		Stop
		set gvar(lifeCount) 0
		$daCV.dataSubscriberAstoBarchartWdg configure -label "Processes died !"
		catch {file delete $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID)-watchdog.pid}
		catch {file delete $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID)}
	} else { 
		set gvar(lifeState) "reviving"
	}
}

#Wait for the new dhsSubscribe to come up.
proc checkRevive {} {
	global gvar env daCV
	
	if { $gvar(lifeCount) == 100 } { 
	#Processes don't come up.
		Debug "Processes don't come up." 1
		Stop
		set gvar(lifeCount) 0
		#$daCV.dataSubscriberAstoBarchartWdg configure -background red
		Alarm
		$daCV.dataSubscriberAstoBarchartWdg configure -label "Processes died !"	
	} elseif {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} result]} {
		incr gvar(lifeCount) 
		Debug "Waiting for new dhsSubscribe to revive: $result" 3
		Debug "lifeCount = $gvar(lifeCount)" 3
	} else {
		Debug "dhsSubscribe revived !" 1
		#dhsSubscribe is revived
		#$daCV.dataSubscriberAstoBarchartWdg configure -background green
		setNormal
		$daCV.dataSubscriberAstoBarchartWdg configure -label "$gvar(fileType) from $env(DHS_HOST)"
		set gvar(loopLifeTime) 10000
		set gvar(lifeState) "alive"
		set gvar(lifeCount) 0
	}
}


#Wait for the DhsSubscribe to be created.
proc checkDeathOld {} {
    global gvar env daCV

    Debug "Waiting for dhsSubscribe to die." 3
    if {$gvar(countPid) == 60} {
	set gvar(cancelDeathLoop) 1
	stopState
	Info "dhsSubscribe  doesn't want to die...kill it manually."
	$daCV.dataSubscriberAstoBarchartWdg configure -label "Stop dhsSubscribe failed"
	after 3000
	#$mainCV.dominoConfigWdg enable
    } else {
	if {[file exists $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} {
	    if {![catch {exec kill -26 [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} result]} { 
		incr gvar(countPid) +1
	    } else {
		$daCV.dataSubscriberAstoBarchartWdg configure -label "dhsSubscribe stopped"
		catch {file delete $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid}
		set gvar(cancelDeathLoop) 1
		stopState
		processLeftovers
		#$daCV.dataSubscriberAstoBarchartWdg configure -label "dhsSubscri"
		return 
 	    }
	} else { 
	    $daCV.dataSubscriberAstoBarchartWdg configure -label "dhsSubscribe stopped"
	    set gvar(cancelLoop) 1
	    stopState
	    processLeftovers  
	}
    }
}

proc checkDeath {} {
    global gvar env daCV

    Debug "Waiting for process to die" 3
    Debug "countPid $gvar(countPid)" 3
    if {$gvar(countPid) == 30} {
	startState
	
	set gvar(cancelDeathLoop) 1
	set gvar(countPid)   0
	set gvar(goFlag)     1
	
	#$gvar(mainCV).dominoConfigWdg disable
	#$gvar(mainCV).dominoStopWdg$type enable
	#panDisableMenuEntry File "New Program ID"
	Info "Stop of dhsSubscribe failed."
    } else {
	Debug "Pid file exists" 3
	if {[catch {exec ps -p  [exec cat $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid]} result]} { 
	    $daCV.dataSubscriberAstoBarchartWdg configure -label "dhsSubscribe stopped"
	    catch {file delete $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).pid}
	    set gvar(cancelDeathLoop) 1
	    stopState
	    processLeftovers
	    Debug "dataSubscriber stopped" 3
	    
	} else { 
	    incr gvar(countPid) +1 
	}
    }
}


proc startState {} {
    global gvar daCV env

    $daCV.dominoStartWdg disable
    $daCV.dominoStopWdg enable
    $daCV.dominoConfigWdg disable

    $daCV.dominoNttWdg.frame.uifBitmap configure -background green
    $daCV.dataSubscriberAstoBarchartWdg configure -label "$gvar(fileType) from $env(DHS_HOST)" 
	set gvar(lifeState) "alive"
	set gvar(lifeCount) 0
	set gvar(loopLifeTime) 10000
	after 6000 selectLog
    after 7000 set gvar(startFlag) 1 
    
}

proc Stop {} {
    global gvar daCV env popflag

    $daCV.dominoStopWdg disable
    set gvar(cancelLoop) 1
    set gvar(cancelLifeLoop) 1
    #Here I put the clean-dhs command
    #exec cleanup-dhsSubscribe $gvar(dhs-subscriberID)
    set stopCommand "dhsSubscribeControl stop asto -id $gvar(dhs-subscriberID)"
    
    Debug "$stopCommand" 1
    eval exec $stopCommand

    #stopState
    #set gvar(countPid) 0
 
    set gvar(goFlag) 0
    set gvar(countPid) 0
    $daCV.dataSubscriberAstoBarchartWdg configure -label "Stopping dhsSubscribe"
    after 3000 "dominoDeathLoop 1000 \"checkDeath \""
    vwait gvar(goFlag)
}


proc stopState {} {
    global gvar daCV env

    #At the beginning everything is disabled
    #If you want to start you have to che the preferences before.
    $daCV.dominoStartWdg disable
    $daCV.dominoStopWdg disable
    $daCV.dominoConfigWdg enable
    $daCV.dominoNttWdg.frame.uifBitmap configure -background grey
    $daCV.dataSubscriberAstoBarchartWdg configure -label "$gvar(fileType) from $env(DHS_HOST)" 
    set gvar(startFlag)        0
    set gvar(expected)         0
    set gvar(fromToLabel)      ""
    set gvar(alreadyRunning)   0
    #set gvar(cancelLoop)       0
    #Enable here Menu Bar


}


proc dominoEditPrefs {} {
    global gvar

    dominoImportPanel dominoPrefsAsto
}


proc processLeftovers {} {
    global gvar daCV env popflag
	

###################################
##### NOT USED FOR THE MOMENT #####
###################################

return


    #Check if there are files under $DHS_DATA
    #In case there are run post-arrival on them
    Debug "DHS_DATA = $env(DHS_DATA)" 1
    switch -- $gvar(fileType) {
	FITS {set fileList [dominoExCom "find $env(DHS_DATA) -type f -name \"*.fits\" -print"]}
	LOG  {set fileList [dominoExCom "find $env(DHS_DATA) -type f -name \"*.log\" -print"]}
	PAF  {set fileList [dominoExCom "find $env(DHS_DATA) -type f -name \"*.paf\" -print"]}
	OTH {set fileList  [dominoExCom "find $env(DHS_DATA) -type f ! -name \"*.fits\" ! -name \"*.log\" ! -name \"*$gvar(archID)*.paf*\"  -print"]}
	default {Info "Error: I cannot recognize file type"
	return }
    }
    if {$fileList != ""} {
	dominoPopUp "There are files under $env(DHS_DATA). Process them ?" 1 0 1
	if {$popflag == 1 } { 
	    $daCV.dataSubscriberAstoBarchartWdg configure -label "Processing existing files."
	    BusyWin $daCV {
		foreach leftfile $fileList {
		    dominoExCom "post-arrival $leftfile $gvar(dhs-subscriberID)"
		}
		$daCV.dataSubscriberAstoBarchartWdg configure -label "Existing files processed."	
	    }
	}
    } else { $daCV.dataSubscriberAstoBarchartWdg configure -label "No existing files to process."}
}

proc checkArrivals {} {
    global gvar daCV env
	
    if {$gvar(startFlag) == 0} { return }
    
    #counts the files queued
    if {[catch {set gvar(filesQueued) [llength [glob $env(DHS_LOG)/.*$gvar(dhs-subscriberID)*.bulk]]}]} {set gvar(filesQueued) 0}
	
    #counts the files processed
    set count [open $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp r]
    gets $count gvar(filesProcessed)
    close $count
    #Debug "File processed = $gvar(filesProcessed)" 1

    #count the files freshely arrived (if any)
    set countpar [open $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp r]
    gets $countpar gvar(filesArrived)
    close $countpar

    #update perc bar
    if {$gvar(dominoTo) != ""} {
	if {[file exists $env(DHS_LOG)/.expected-$gvar(dhs-subscriberID).tmp]} {
	    if {[catch {set expfile [open $env(DHS_LOG)/.expected-$gvar(dhs-subscriberID).tmp r]}]} {Info "Cannot open $env(DHS_LOG)/.expected-$gvar(dhs-subscriberID).tmp" ; return }
	    gets $expfile gvar(expected)
	    close $expfile
	    set gvar(filesArrived) 0
	    Debug "I expect $gvar(expected) frames" 1
	    if {$gvar(expected) == "" } {
		Debug "Expect file empty. Try again..." 1
		return 
	    } else {
		file delete $env(DHS_LOG)/.expected-$gvar(dhs-subscriberID).tmp
		Debug "Expected $env(DHS_LOG)/.expected-$gvar(dhs-subscriberID).tmp deleted" 3}
		if {$gvar(expected) == 0} { 
		    set gvar(perc) 0
		    Debug "Nothing to retrieve" 1
		    Stop 
	    } else {writeSchemaInfo} 
	    if {!$gvar(alreadyRunning)} {
	    if {[catch {set countpar [open $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp w]}]} {Info "Cannot open $env(DHS_LOG)/.counter-$gvar(dhs-subscriberID).tmp"}
	    puts $countpar "0"
	    close $countpar
	    catch {exec chmod g+x $env(DHS_LOG)/.counter-par-$gvar(dhs-subscriberID).tmp}
	    }
	    set gvar(filesArrived) 0
	    set gvar(perc) 0
	    set gvar(cancelLoop) 1
	    after 5000 "dominoLoop 10000 checkArrivals"
	} else { 
	    if {$gvar(filesArrived) != "" && $gvar(expected) != 0 } {
		Debug "Files Arrived = $gvar(filesArrived)" 1
		Debug "Files Expected =  $gvar(expected)" 1
		set gvar(perc) [expr {($gvar(filesArrived) * 100)/$gvar(expected)}]; Debug "We received $gvar(perc) %" 1
	    if {$gvar(filesArrived) == $gvar(expected)} { 
		set gvar(perc) 0
		Debug "Everything has arrived" 1
		Stop }
	    }
	}
    } 
    
    #Check if a new logfile has been created.
    if {[catch {set newlog [lindex [lsort -decreasing [glob  $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).????-??-??] ] 0 ]}]} {
	Debug "Still no log - $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID)" 1 
	set newlog ""
    }

    if {$newlog != $gvar(lastLog)} {set gvar(lastLog) $newlog
	Debug "*** The new log is $gvar(lastLog) ***" 1
	set gvar(errorNum) 0}
    
    if {![catch {set newErrors [exec grep -c ERROR $gvar(lastLog)]}]} { if {$newErrors > $gvar(errorNum)} {set gvar(errorNum) $newErrors
	Alarm }
    } else { return }
}

proc showLog {} {
    global gvar

    selectLog
    
    #This is the old way to show the log.
    #set buf [exec tail -100 $gvar(lastLog)]
    #panTerm "DHS Log" $buf

    if {![info exists gvar(lastLog)] || ![file readable $gvar(lastLog)]} {Info "There is no log file." ; return }
    exec xterm  -title "Log: $gvar(lastLog)" -geometry 80X10 -fn fixed -e tail -f $gvar(lastLog) &
}


proc selectLog {} {
    global gvar env daCV

    #set list [glob $env(DHS_LOG)/DhsSubscribe.*]
    #Debug "List = $list"
    #set sort [lsort -decreasing [glob $env(DHS_LOG)/DhsSubscribe.*] ]
    #Debug $sort
    
    if {![catch {set gvar(lastLog) [lindex [lsort -decreasing [glob $env(DHS_LOG)/DhsSubscribe-$env(HOST)-$gvar(dhs-subscriberID).????-??-??] ] 0 ]}]} {
	#$daCV.dominoShowLogWdg enable
	Debug "Consider log: $gvar(lastLog)" 1
    } else {Debug "log file not found" 1
	set gvar(lastLog) ""}

	if {[catch {set gvar(errorNum) [exec grep -c ERROR $gvar(lastLog)]}]} {
	    set gvar(errorNum) 0}
    
}

##########################################################################
#                            Utilities                                   #
##########################################################################

proc dominoExCom {cmd} {
    global execOutput execErrors
    set execStatus 0
    Debug "Ex: $cmd" 1
    if {[catch {eval blt::bgexec execStatus -output execOutput \
	    -error execErrors [lindex $cmd 0] [lrange $cmd 1 end]} msg]} {
	Info "Error invoking command:\n\
		\"$cmd\""
	Debug "ExCom Error: $execErrors" 1
	return -1
    }
    # vwait
    # tkwait variable execStatus
    set execStatus 0
    return $execOutput
}


# This procedure imports the panel into the parent panel,
# and waits on a gvar() variable called:
#
# gvar(<panel name>_exit)
#
# for the panel to signal that the imported panel has
# terminated
proc dominoImportPanel {panel {inputVar ""}} {
    global gvar env daCV

    set gvar(${panel}_exit) 0
    set oldCv $daCV
    panImportPanel $panel $inputVar
    vwait gvar(${panel}_exit)
    set daCV $oldCv
}

proc dominoClose {} {
    global gvar  env popflag
    
    if {$gvar(alreadyRunning) == 1} {
	set answer [tk_messageBox -message "dhsSubscribe is (are) still running !\n \
        Do you want to stop it (them) before exiting ?" -type yesnocancel -icon question]
	switch -- $answer {
	    yes {Stop}
	    cancel { return }
	}
    }
    #panClosePanel no
    #catch {file delete $env(DHS_LOG)/dataSubscriberAsto-$gvar(dhs-subscriberID).pid}
    exit
}

proc dominoImportKey {} {
    
    dominoImportPanel dominoKeyAsto
    
    if {$gvar(dominoRename) == 1 && $gvar(dominoBrowseKeyword) == "" } {
	set gvar(dominoTrans) 0 }
}

proc dominoImportHt {} {
    
    dominoImportPanel ht
    
    if {$gvar(dominoTrans) == 1 && $gvar(selCleanTable) == "" } {
	set gvar(dominoTrans) 0 }   
}

#Loop routine.
proc dominoLoop { time cmd } {
  global gvar

    if {$gvar(cancelLoop) == 1} {
	set gvar(cancelLoop) 0
	if {[info exists gvar(loopId)]} {
	    after cancel $gvar(loopId)
	    Debug  "Loop dominoLoop  - $gvar(loopId) killed " 3
	}
	} else {
	eval $cmd
	set gvar(loopId) [after $time dominoLoop $time \"$cmd\" ]
	Debug "LoopID = $gvar(loopId) -- cmd = $cmd -- time = $time" 3 
    }
}


#Loop routine for living processes.
proc dominoLifeLoop { cmd } {
  global gvar
	
    if {$gvar(cancelLifeLoop) == 1} {
	set gvar(cancelLifeLoop) 0
	if {[info exists gvar(loopLifeId)]} {
	    after cancel $gvar(loopLifeId)
	    Debug  "Loop dominoLifeLoop - $gvar(loopLifeId) - $cmd - killed " 3
	}
    } else {
	eval $cmd
	set gvar(loopLifeId) [after $gvar(loopLifeTime)  dominoLifeLoop \"$cmd\" ]
	Debug "LoopID = $gvar(loopLifeId) -- cmd = $cmd" 3
    }
}

#Loop routine for dead processes.
proc dominoDeathLoop { time cmd} {
    global gvar
    
    if {$gvar(cancelDeathLoop) == 1} {
	set gvar(cancelDeathLoop) 0
	if {[info exists gvar(loopDeathId)]} {
	    after cancel $gvar(loopDeathId)
	    Debug  "Loop dominoDeathLoop - $gvar(loopDeathId) - $cmd - killed " 3
	}
    } else {
	eval $cmd
	set gvar(loopDeathId) [after $time dominoDeathLoop $time \"$cmd\"]
	Debug "LoopID = $gvar(loopDeathId) -- cmd = $cmd" 3
    }
}

#proc dominoLoop { cmd } {
#  eval $cmd
#  after 10000 dominoLoop $cmd
#}

proc setNormal {} {
    global gvar daCV
    
    if {$gvar(startFlag)} {
    $daCV.dominoNttWdg configure -hotSpotColor green
    $daCV.dominoNttWdg.frame.uifBitmap configure -background green
    }
}


proc Alarm {} {
    global gvar daCV

    $daCV.dominoNttWdg configure -hotSpotColor red
    $daCV.dominoNttWdg.frame.uifBitmap configure -background red
    Debug "Alarm icon red !" 1
}

proc htNewKeyCheck {newKey} {
    global gvar daCV env
    
    #If Eso Keyword is empty it means that we are 
    #introducing a new keyword
    
    if {[string compare $newKey "BACKSPACE"] == 0} { return }
    
    if {![string match {[A-Z]} $newKey] && ![string match {[0-9]} $newKey] && 
	![string match "MINUS" $newKey] && ![string match "UNDERSCORE" $newKey] } {set newKey ""}
    
    if {$newKey == "MINUS"} {set newKey "-"}
    if {$newKey == "UNDERSCORE" } {set newKey "_"}
    if {[string length $gvar(htNewKey)] == 8} {set newKey ""} 
    
    set tmpkey [string toupper $gvar(htNewKey)$newKey]
    update
    after 10 set gvar(htNewKey) $tmpkey	
    after 10 $daCV.dicBrowseKeywordWdg.uifEntry icursor end
  
}

proc dominoPopUp { mess1 yesflag okflag noflag } {
    global errorInfo popflag
    set w .dominoPopUp

    if {[winfo exists $w]} { destroy $w }

    set title  "Error Dialog"

    # Determine an estimate of the window width

    set len       [string length $mess1]
    set msgWidth  "8i"
    if {[set idx [string first "\n" $mess1]] != -1 } {
        set len $idx
    }

    if {$len > 36 } { set msgWidth "12i" }

    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog

    frame $w.top -relief raised -bd 1
    frame $w.bot -relief raised -bd 1

    #label $w.lbl1 -text "Tcl/Tk Error Stack" \
        #              -font "-Adobe-helvetica-bold-r-normal--14*"

    #UifText $w.stack -width 36 -height 8 \
        #                 -font "-Adobe-courier-medium-r-normal--12*"

    pack $w.top            -fill both
    #pack $w.lbl1  -pady 5  -fill x
    #pack $w.stack -pady 3  -expand yes -fill x
    pack $w.bot            -expand yes -fill x

    #$w.stack insertText 0.0 $errorInfo

    #
    # Fill the top part with bitmap and message.
    #

 message $w.msg -width $msgWidth  -text $mess1 \
        -font -Adobe-Times-Medium-R-Normal-*-180-*
    pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 5m -pady 5m

    #
    # Create a row of buttons at the bottom of the dialog.
    #
    frame $w.bottoni -relief sunken -bd 1
    button $w.bottoni.yes -text YES -command "set popflag 1"

    button $w.bottoni.ok -text OK -command "set popflag 2"
    button $w.bottoni.no -text NO -command "set popflag 0"
    pack append $w.bottoni $w.bottoni.yes {left expand fillx padx 30} \
        $w.bottoni.ok {left expand fillx padx 30} \
        $w.bottoni.no {left expand fillx padx 30}
    pack append $w $w.bottoni {top fill}

    if {$yesflag == 1} {$w.bottoni.yes configure -state normal
    } else {$w.bottoni.yes configure -state disabled}

    if {$okflag == 1} {$w.bottoni.ok configure -state normal
    } else {$w.bottoni.ok configure -state disabled}

    if {$noflag == 1} {$w.bottoni.no configure -state normal
    } else {$w.bottoni.no configure -state disabled}

    update idletasks

    # Set a grab and claim the focus too.

    set oldFocus [focus]
    grab $w ; focus $w


    # Set Geometry to allow the user to re-size only along X

    set geo    [wm geometry $w]
    scan $geo "%dx%d+%d+%d" wid hei posx posy

    wm minsize $w $wid $hei
    wm maxsize $w 1000 $hei
    #
    # Wait for the user to respond, then restore the focus and
    # return the index of the selected button.
    #

    tkwait variable popflag
    destroy $w
    return $popflag

}

#-----------------------------------------------------------------------------
# Run the tcl command $cmd while displaying the busy cursor in  window $w.
# Also works to block a listbox but allow the scrollbars to 
# still be used. ($W should probably not be '.', use Busy for that).
#
# Note: had problems in Tk3.6 here with watch cursor showing up after
# deiconfiying the window. Try again in Tk4.0 ?
#-----------------------------------------------------------------------------
proc BusyWin {w cmd} {
    global errorInfo busywin_count

    if {! [info exists busywin_count($w)]} {
        set busywin_count($w) 0
    }

    if {[incr busywin_count($w)] == 1} {
        #       set focus [focus]
        #       focus none
        eval blt::busy hold $w -cursor watch
        update idletasks
        update
    }
    
    # save any errors and report them later
    if {[set code [catch [list uplevel $cmd] msg]]} {
        set info $errorInfo
    } 

    if {[incr busywin_count($w) -1] == 0} {
        update idletasks
        blt::busy release $w
        #       catch {focus $focus}
    }

    if {$code} {
        return -code $code -errorinfo $info $msg
    }
}





#Parse the arguments from the command line and set some options
proc setDominoAstoOptions {} {
    global gvar

    regsub -all "{" $gvar(args) "" gvar(args)
    regsub -all "}" $gvar(args) "" gvar(args)
    
    for { set i 0} {$i <[llength $gvar(args)]} {incr i} {
        switch -- [lindex $gvar(args) $i] {
			-info {
				incr i
				explainAll
			} 
			-debug {
				incr i
				set level [lindex $gvar(args) $i]
				if {$level == "" || $level > 3 || $level < 1} {
					explain
				}
				set gvar(debugMode) $level
			}
			-log {
				incr i
				set logFile [lindex $gvar(args) $i]
				if {[catch {set gvar(logFile) [open $logFile a]} var]} {
					puts "Cannot open $logFile"
					exit }
				if {![info exists gvar(debugMode)]} { set gvar(debugMode) 1 }
			} 
			-filetype {
				incr i
				set filetype [lindex $gvar(args) $i]
				if {$filetype != "FITS" && \
						$filetype != "PAF" && \
						$filetype != "LOG" && \
						$filetype != "OTH"} { explain 
				} else { set gvar(fileType) $filetype }
			} 
			-archid {
				incr i
				set gvar(archID) [lindex $gvar(args) $i]
			} 
			-from {
				incr i
				set gvar(dominoFrom) [lindex $gvar(args) $i]
			} 
			-to {
				incr i
				set gvar(dominoTo) [lindex $gvar(args) $i]
			} 
			default {
				puts "Unknown option: [lindex $gvar(args) $i]"
				explain
			}
		}
    }
}

#I won't explain explain =;-)
proc explain {} {
    global gvar

    puts "Usage: dataSubscriberAsto -info -filetype <FITS;PAF;LOG;OTH> \n-archid<archive id>\n-from <YYYY-MM-DD> \{-to <YYYY-MM-DD>\}\n -log <filename> -debug \[1-3\]"
    exit
}


proc explainAll {} {
    puts "-info           : This message"
    puts "-filetype       : The type of files to be retrieved from the"
    puts "                : DHS system. It can be: FITS, PAF, LOG, OTH"
    puts "-archid         : ID used to distinguish different dhsSubscribers"
    puts "-from           : Date from which dhsSubscribe retreives data"
    puts "-to             : Date until which dhsSubscribe retreives data"
    puts "-log <filename> : Puts all the messages in the specified file"
    puts "                : If you don't specify -debug the verbose level"
    puts "                : will be set to 1"
    puts "-debug \[1-3\]  : Define the verbose level"
    exit
}


#Pop up info boxes.
proc Info {text} {
    #puts "Info> $text"
    tk_dialog .info "Asto Dialog" $text info 0 OK
    Debug $text 1
}

#Debug procedure, it shows internal messages
proc Debug {text level} {
    global gvar

    #if {![info exists gvar(HtVerbose)] || $gvar(HtVerbose) == "0" } { return }
    if {![info exists gvar(debugMode)]} { return }

    if { $gvar(debugMode) <  $level } { return }
    set date [clock format [clock seconds] -format "%Y-%m-%d %T"]

    if {[info exists gvar(logFile)]} {puts $gvar(logFile) "Debug>\[$date\] $text"
    } else { puts "Debug>\[$date\] $text" }
}
#
# ___oOo___
