#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dpViewer.pan,v 1.1 2004/09/06 14:47:14 cguirao Exp $" 
#
# dpViewer.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 4.10+
#   date   : Thu Nov 26 15:36:16 MET 1998
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}
set gvar(args) $argv
#
# Link panel to user libraries 
#
set panUsrLib   {libolasControlLib }  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .dpViewer 
   set panUsrProcs {dpViewerInit dpViewerExit dpViewerInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc dpViewerInitData {} {

 # Declare global variables

   global <var>
#return
dpSetOptions
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc dpViewerInit {} {

 # Declare global variables
global gvar cv


 # User Initialization
[$cv.dpViewerListWdg component uifFancyListBox] configure -font 9x15
#return
   dpViewerInitX
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      1 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     1 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
set par(PANELX) 242 ;# Panel X position
set par(PANELY) 225 ;# Panel Y position
panCreateFrame dpViewer ;# Create empty frame
panGetCvNames  dpViewer cv bcv ;# Get Canvas Names
panInit        $argc $argv dpViewer ;# Initialization



UifCheckButton     $cv.dpAutoUpdate -anchor w -canvasAnchor nw \
                   -command dpAUToggle -default 0 -label {Auto Update} \
                   -offVal 0 -onVal 1 -variable gvar(dpAutoUpdate) -width 0
UifEntry           $cv.dpExpStartFromWdg -canvasAnchor nw \
                   -labelFont -Adobe-courier-medium-r-normal--14* \
                   -labelWidth 0 -maxVal 100 -minVal 0 \
                   -variable gvar(dpExpStartFrom) -width 10
UifEntry           $cv.dpExpStartToWdg -canvasAnchor nw \
                   -labelFont -Adobe-courier-medium-r-normal--14* \
                   -labelWidth 0 -maxVal 100 -minVal 0 \
                   -variable gvar(dpExpStartTo) -width 10
UifEntry           $cv.dpUpdateTimeWdg -canvasAnchor nw \
                   -labelFont -Adobe-courier-medium-r-normal--14* \
                   -labelWidth 0 -maxVal 100 -minVal 0 \
                   -variable gvar(dpUpdateTime) -width 3
UifOutput          $cv.dpViewer-wdg1 -anchor w -canvasAnchor nw -color Black \
                   -font -Adobe-courier-medium-r-normal--12* -frame 0 \
                   -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-* \
                   -labelWidth 0 -width 0
UifOutput          $cv.dpViewer-wdg2 -anchor w -canvasAnchor nw -color Black \
                   -font -Adobe-courier-medium-r-normal--14* -frame 0 \
                   -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-* \
                   -labelWidth 0 -variable gvar(dpViewerHdr) -width 85
UifButton          $cv.dpViewerCancelWdg -canvasAnchor nw -command Sybcancel \
                   -initialState normal -label {Cancel Request} -popup 0 \
                   -stateVar gvar(dpViewer-wdg9Var) -width 14
UifFancyListBox    $cv.dpViewerListWdg -activebackground Black \
                   -background Grey80 -borderwidth 2 \
                   -font -Adobe-courier-medium-r-normal--14* -geometry 80x5 \
                   -height 24 -initialState normal -relief sunken -scrollx 1 \
                   -scrolly 1 -selectmode single -wrap none
UifButton          $cv.dpViewerQueryWdg -canvasAnchor nw \
                   -command dpViewerQuery -initialState normal -label Query \
                   -popup 0 -stateVar gvar(dpViewer-wdg2Var) -width 10
UifButton          $cv.dpViewerQuitWdg -canvasAnchor nw \
                   -command dpViewerClosePanel -initialState normal \
                   -label Quit -popup 0 -stateVar gvar(dpViewer-wdg3Var) \
                   -width 10

#
#  Canvas Items
#

$cv create text 8 416 -tags "text dpViewer-item1" -anchor nw \
          -text "From:" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 148 416 -tags "text dpViewer-item2" -anchor nw \
          -text "To:" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 372 416 -tags "text dpViewer-item3" -anchor nw \
          -text "sec." \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 


#
# Set Widget Configuration
#
set panWidget(dpAutoUpdate)  {UifCheckButton 264.0 412.0 1 0 0 0 0 dpAutoUpdate 0 0 1 0 0 0}
set panWidget(dpExpStartFromWdg)  {UifEntry 48.0 415.0 1 0 {} 0 0 dpExpStartFrom 0 N 0 100 0 0 0 0}
set panWidget(dpExpStartToWdg)  {UifEntry 172.0 415.0 1 0 {} 0 0 dpExpStartTo 0 N 0 100 0 0 0 0}
set panWidget(dpUpdateTimeWdg)  {UifEntry 400.0 415.0 1 0 {} 0 0 dpUpdateTime 0 N 0 100 0 0 0 0}
set panWidget(dpViewer-wdg1)  {UifOutput 20 16 1 0 0 0 0 dpViewerHdr 0 {} {}}
set panWidget(dpViewer-wdg2)  {UifOutput 4 0 1 0 0 0 0 dpViewerHdr 0 {} {}}
set panWidget(dpViewerCancelWdg)  {UifButton 528 412 1 0 0 0 0 {} 0 {}}
set panWidget(dpViewerListWdg)  {PubClass 4 24 1 0 libolasControlLib.tcl nw 0 {} 0}
set panWidget(dpViewerQueryWdg)  {UifButton 436 412 1 0 0 0 0 {} 0 {}}
set panWidget(dpViewerQuitWdg)  {UifButton 652 412 1 0 0 0 0 {} 0 {}}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#
set panWidgetHlp(dpAutoUpdate)  {Automatic update. To: field must be empty.}
set panWidgetHlp(dpExpStartFromWdg)  {From date: <YYYY-MM-DD>}
set panWidgetHlp(dpExpStartToWdg)  {To date: <YYYY-MM-DD> Leave it empty and select Auto Update for automatic update.}
set panWidgetHlp(dpViewerCancelWdg)  {Cancel query.}
set panWidgetHlp(dpViewerListWdg)  {Show info about Data Products. Select Help to show info about the flags.}
set panWidgetHlp(dpViewerQueryWdg)  {Update the listbox.}
set panWidgetHlp(dpViewerQuitWdg)  {Close the panel.}

#
#-----------------------------------------------
#           Menu Bar Definition  
#-----------------------------------------------
# 

set menu(0) {File 1 file}
set menu(1) {Help -1 help {}}


# Add MenuButton < File > 

set mb [addMenuButton $menuBar file " File " -1 left]

# Menu  

addMenuCmd $mb "Quit" 0 {panClosePanel}

# Add MenuButton <Help> 

set mb [addMenuButton $menuBar help "Help" -1 right]

# Menu  

addMenuCmd $mb "Describe Flags" -1 {showFlags}

#
#-----------------------------------------------
#           Menu Help Definition  
#-----------------------------------------------
# 


#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 748x517
wm title     $panRoot "Data Product Viewer"
set par(TITLE) "Data Product Viewer" 

panMainStart  dpViewer $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc dpViewerExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
