#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: olasControl.pan,v 1.1 2004/09/06 14:47:14 cguirao Exp $" 
#
# olasControl.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 4.10+
#   date   : Thu Nov 26 11:12:10 MET 1998
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}

set gvar(args) $argv

#
# Link panel to user libraries 
#
set panUsrLib   {libolasControlLib }  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .olasControl 
   set panUsrProcs {olasControlInit olasControlExit olasControlInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc olasControlInitData {} {

 # Declare global variables

   global <var>
#return
setOptions
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc olasControlInit {} {
    global cv gvar
 # Declare global variables

   global gvar env

#setOptions
[$cv.olasControlListWdg component uifFancyListBox] configure -font 9x15
 # User Initialization
#puts "Arguments are: $gvar(argv)"
#return
   olasControlInitX
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      1 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     1 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
set par(PANELX) 26 ;# Panel X position
set par(PANELY) 202 ;# Panel Y position
panCreateFrame olasControl ;# Create empty frame
panGetCvNames  olasControl cv bcv ;# Get Canvas Names
panInit        $argc $argv olasControl ;# Initialization



UifEntry           $cv.expStartFromWdg -canvasAnchor nw -default 1998-12-12 \
                   -labelFont -Adobe-helvetica-medium-r-normal--24* \
                   -labelWidth 0 -maxVal 100 -minVal 0 \
                   -variable gvar(expStartFrom) -width 10
UifEntry           $cv.expStartToWdg -canvasAnchor nw \
                   -labelFont -Adobe-courier-medium-r-normal--14* \
                   -labelWidth 0 -variable gvar(expStartTo) -width 10
UifOutput          $cv.olasControl-wdg1 -anchor w -canvasAnchor nw \
                   -color Black -font -Adobe-courier-medium-r-normal--14* \
                   -frame 0 \
                   -labelFont -Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-* \
                   -labelWidth 0 -variable gvar(olasControlHdr) -width 83
UifCheckButton     $cv.olasControl-wdg2 -anchor w -canvasAnchor nw \
                   -command olasAUToggle -default 0 -label {Auto Update} \
                   -offVal 0 -onVal 1 -variable gvar(autoUpdate) -width 0
UifButton          $cv.olasControlCancelWdg -canvasAnchor nw \
                   -command {.olasControl.bot.sh displayText "Query cancelled !"; Sybcancel} \
                   -initialState normal -label {Cancel Query} -popup 0 \
                   -stateVar gvar(olasControl-wdg8Var) -width 14
UifFancyListBox    $cv.olasControlListWdg -activebackground Black \
                   -background Grey80 -borderwidth 2 \
                   -font -Adobe-courier-medium-r-normal--14* -geometry 85x5 \
                   -height 24 -initialState normal -relief sunken -scrollx 1 \
                   -scrolly 1 -selectmode single -wrap none
UifButton          $cv.olasControlQuitWdg -canvasAnchor nw \
                   -command olasControlClose -initialState normal \
                   -label Quit -popup 0 -stateVar gvar(olasControl-wdg3Var) \
                   -width 10
UifButton          $cv.olasControlRefreshWdg -canvasAnchor nw \
                   -command olasControlUpdateList -initialState normal \
                   -label Query -popup 0 \
                   -stateVar gvar(olasControl-wdg2Var) -width 10
UifEntry           $cv.updateTimeWdg -canvasAnchor nw \
                   -labelFont -Adobe-courier-medium-r-normal--14* \
                   -labelWidth 0 -maxVal 999 -minVal 0 \
                   -variable gvar(updateTime) -width 3

#
#  Canvas Items
#

$cv create text 20 8 -tags "text olasControl-item1" -anchor nw \
          -text "obs_name" \
          -fill black -font -Adobe-courier-medium-r-normal--14* 

$cv create text 12 441 -tags "text olasControl-item2" -anchor nw \
          -text "From:" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 148 441 -tags "text olasControl-item3" -anchor nw \
          -text "To:" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 388 441 -tags "text olasControl-item4" -anchor nw \
          -text "sec." \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 


#
# Set Widget Configuration
#
set panWidget(expStartFromWdg)  {UifEntry 52.0 440.0 1 0 1998-12-12 0 0 expStartFrom 0 A {} {} 0 0 0 0}
set panWidget(expStartToWdg)  {UifEntry 172 440 1 0 {} 0 0 expStartTo 0 A {} {} 0 0 0 0}
set panWidget(olasControl-wdg1)  {UifOutput 20 24 1 0 0 0 0 olasControlHdr 0 {} {}}
set panWidget(olasControl-wdg2)  {UifCheckButton 280 437 1 0 0 0 0 autoUpdate 0 0 1 0 0 0}
set panWidget(olasControlCancelWdg)  {UifButton 568 436 1 0 0 0 0 {} 0 {}}
set panWidget(olasControlListWdg)  {PubClass 4 48 1 0 libolasControlLib.tcl nw 0 {} 0}
set panWidget(olasControlQuitWdg)  {UifButton 692 436 1 0 0 0 0 {} 0 {}}
set panWidget(olasControlRefreshWdg)  {UifButton 476 436 1 0 0 0 0 {} 0 {}}
set panWidget(updateTimeWdg)  {UifEntry 424 440 1 0 {} 0 0 updateTime 0 N 0 999 0 0 0 0}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#
set panWidgetHlp(expStartFromWdg)  {From date: <YYYY-MM-DD>}
set panWidgetHlp(expStartToWdg)  {To date: <YYYY-MM-DD>.}
set panWidgetHlp(olasControl-wdg2)  {Automatic update.}
set panWidgetHlp(olasControlCancelWdg)  {Cancel the current query.}
set panWidgetHlp(olasControlListWdg)  {Show info about OBs.}
set panWidgetHlp(olasControlQuitWdg)  {Close the panel.}
set panWidgetHlp(olasControlRefreshWdg)  {Update the listbox.}
set panWidgetHlp(updateTimeWdg)  {Refresh rate in seconds (Max. 999 seconds)}

#
#-----------------------------------------------
#           Menu Bar Definition  
#-----------------------------------------------
# 

set menu(0) {File 1 file}
set menu(1) {View -1 view {}}


# Add MenuButton < File > 

set mb [addMenuButton $menuBar file " File " -1 left]

# Menu  

addMenuCmd $mb "Quit" 0 {olasControlClose}

# Add MenuButton <View> 

set mb [addMenuButton $menuBar view "View" -1 left]

# Menu  

addMenuCmd $mb "dpViewer" -1 {callDpViewer}
addMenuCmd $mb "Show all" 0 {viewAll 1}
addMenuCmd $mb "Hide All" 0 {viewAll 0}

#
#-----------------------------------------------
#           Menu Help Definition  
#-----------------------------------------------
# 


#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 791x545
wm title     $panRoot "Olas Control"
set par(TITLE) "Olas Control" 

panMainStart  olasControl $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc olasControlExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
