# File   : orangRank.tcl
# Purpose: Test
# Author : Paulo Nunes
# Date   : Mon Aug 29  2005
# This is an example ranking algorithm


proc rank ob {
	## read variables needed by the algorithm
	
	set userPriority [getUserPriority $ob]
	set airmass [getAirmass $ob]
	set dec [getDec $ob]
	set ra [getRa $ob]
	set diffDec [getDiffDec $ob]
	set diffRA [getDiffRA $ob]	
	set fli [getFLI $ob]	
	set moonAngularDistance [getMoonAngularDistance $ob]
	set propDec [getPropDec $ob]
	set propRA [getPropRA $ob]
	set seeing [getSeeing $ob]	
	set skyTransparency [getSkyTransparency $ob]	
	set strehlRatio [getStrehlRatio $ob]
	set executionTime [getExecutionTime $ob]
	set period [getPeriod $ob]
	set progId [getProgId $ob]
	set obsMode [getObsMode $ob]
	set telescope [getTelescope $ob]
	set rankClass [getRankClass $ob]
	set rank [getRank $ob]
	set timeCritical [getTimeCritical $ob]
	set chilean [getChilean $ob]
	set preImaging [getPreImaging $ob]
	set carryOver [getCarryOver $ob]
	set large [getLarge $ob]
	set secondHalfTI [getSecondHalfTI $ob]
	set runStarted [getRunStarted $ob]
	set lst [getLST $ob]
	set ha [getHourAngle $ob]
		
	
		
	## append the score string
	if  {$rankClass == "A"}  {
		append score "A"
			
	} elseif {$rankClass == "B" }  {		
		append score "B"
				
	} elseif {$rankClass == "C" }  {
		append score "C"	
	} else {
		append score "Z"	
	}
	
	## timeCritical
	if {$timeCritical} {
		append score ".TC1"
	} else {
		append score ".TC2"
	}

	#second Half of TimeInterval or not
	if $secondHalfTI  {
		append score ".T1"
	} else {
		append score ".T2"
	}
	
	# seeing
	append score "S" $seeing
	
	##  transparency can be "Photometric", "Clear",
	## "Variable, thin cirrus" or "Variable, thick cirrus"

	if {$skyTransparency == "4THK"} {
		append score ".ST1"
	} elseif {$skyTransparency == "3THN"}  {
		append score ".ST2"
	} elseif {$skyTransparency == "2CLR"} {
		append score ".ST3"
	} elseif {$skyTransparency == "1PHO"} {
		append score ".ST4"
	} else {
		append score ".ZZZ"
	}
	
	## Hour angle
	append score ".HA$ha"
			
	## RA, FLI and Internal priority 
	append score ".RA" + $ra
	append score ".FLI" + $fli
	append score ".PR" + $userPriority
			
	return $score
}



## this have to be always called
init
rankall

# end of file orangRank.tcl
