/**
 * @author N. Kornweibel
 * @version 1.0
 * Swing Panel to display a DFSTextFile.
 */
package org.eso.gasgano.datamodel.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;

public class DFSTextFileDisplay extends JPanel {

    /**
     * @param title The title of the Panel.
     * @param data The text from the DFSTextFile.
     */

    static JEditorPane editorPane = new JEditorPane("text/html", "");
    static JScrollPane scrollPane = new JScrollPane();

    public static void main(String[] args) {
        final JFrame myApp = new JFrame();
        final JPanel myPanel = new JPanel(new BorderLayout());
        StringBuffer strBuffer =
            new StringBuffer("lkdfjldskfjgdlkfjgldkfgjldkfjglkdfjgldkfjg\n");
        for (int i = 0; i < 8; i++) {
            strBuffer.append(strBuffer.toString());
        }
        final String myString = new String(strBuffer.toString());
        DFSTextFileDisplay fileDisp =
            new DFSTextFileDisplay("test display", myString);
        myPanel.add(fileDisp, "East");

        myApp.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        myApp.getContentPane().add(myPanel);
        myApp.pack();
        myApp.setLocation(300, 300);
        myApp.setSize(600, 600);
        myApp.setVisible(true);
    }

    public DFSTextFileDisplay(String title, String data) {
        super(new BorderLayout());
        JTextArea textArea = null;
        JPanel titlePanel = new JPanel();
        setBorder(new EmptyBorder(2, 5, 2, 2));
        titlePanel.add(new JLabel(title));
        scrollPane.setHorizontalScrollBarPolicy(
            JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        scrollPane.setVerticalScrollBarPolicy(
            JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);

        add(titlePanel, BorderLayout.NORTH);
        if (data.indexOf("recipe") != -1 && data.indexOf("instrument") != -1) {

            editorPane.setText(htmlizeData(data));
            editorPane.setEditable(false);
            editorPane.setMaximumSize(new Dimension(600, 600));
            editorPane.setPreferredSize(new Dimension(400, 600));
            editorPane.setMinimumSize(new Dimension(400, 600));

            scrollPane.setViewportView(editorPane);
            add(scrollPane, BorderLayout.CENTER);

            editorPane.setCaretPosition(0);
        } else {
            textArea = new JTextArea(data);
            textArea.setEditable(false);
            textArea.setCaretPosition(0);

            scrollPane.setViewportView(textArea);
            add(scrollPane, BorderLayout.CENTER);
        }
    }

    private String htmlizeData(String data) {
        int loc = 0;
        StringBuffer sb = new StringBuffer();
        sb.insert(0, "<html>\n<head>\n</head>\n<body>\n");
        for (int i = 0; i < data.length(); i++) {
            if (data.charAt(i) == '\n') {
                sb.append("<br>");
            } else {
                sb.append(data.charAt(i));
            }
        }
        sb.append("\n</body>");
        loc = sb.toString().indexOf("recipe");
        if (loc != -1) {
            sb.insert(loc + 6, "</b>");
            sb.insert(loc, "<b>");
            loc = sb.toString().indexOf("instrument");
            if (loc != -1) {
                sb.insert(loc + 10, "</b>");
                sb.insert(loc, "<b>");
                loc = sb.toString().indexOf("<br>", loc);

                if (loc != -1) {
                    sb.insert(loc + 4, "<font color=#FF0000>");
                }

                loc = sb.toString().indexOf('{', loc);

                if (loc != -1) {
                    sb.insert(loc, "</font>");
                    sb.insert(loc + 8, "<font color=#0000FF>");
                    loc = sb.toString().indexOf('}', loc);
                    sb.insert(loc, "</font>");

                    loc = sb.toString().indexOf('{', loc);
                    if (loc != -1) {
                        sb.insert(loc + 1, "<font color=#FF8800>");
                        loc = sb.toString().indexOf('}', loc);
                        sb.insert(loc, "</font>");
                    }
                }
            }
        }
        //System.out.println(sb);
        return sb.toString();
    }
} // end of class DFSTextFileDisplay

// end of file DFSTextFileDisplay.java
