package org.eso.gasgano.properties;

/**
 * @author nkornwei
 *
 * Interface for providing property values across the Gasgano system.
 */
public interface PropertySource {

    /**
     * Get a property.
     * @param name the name of the property to fetch.
     * @return String value of requested property.
     */
    public String getProperty(String name);
    
    /**
     * Set a property, or null if not found.
     * @param name of property to set
     * @param value of property to set
     * @return the value set - (done for paramllelism with Properties class).
     */
    public Object setProperty(String name, String value);

}
