package org.eso.gasgano.viewers;

import java.util.Vector;

/**
 * @author nkornwei
 *
 * This is the base interface implemented by all external viewers.
 * The instances of the viewers are created through the
 * ExternalViewerFactory, where each implementing class
 * must be registered along with its type keyword.
 */
public interface ExternalViewer {

    /**
     * The command configured with this viewer
     */
    public void setCommand(String command);
    
    /**
     * Display the requested files in the viewer
     * the full file paths is retreived from the Vector
     * elements using the toString() method.
     */
    public void displayFiles(Vector fullFilePaths) throws ExternalViewerException;
}
