package org.eso.ohs.core.dbb.client;

import java.text.ParseException;

import org.eso.ohs.core.utilities.Convert;

/**
 * $Id: DbbISODateTime.java,v 1.3 2005/04/11 13:53:44 tcanavan Exp $
 * @author amchavan, 09-Oct-2001: creation from Coordinate.java 
 */

public class DbbISODateTime implements DbbDataType  {
    
    public final static int ISO_STRING_LENGTH = 19;

    
    /** 
     * @return An ISO date+time string equivalent to the input integer.
     *
     * @see Convert#longToISODate( long )
     */

    public String fromDatabaseData( Object obj ) {
        long seconds = ((Integer)obj).longValue();
        String ret = Convert.longToISODate( seconds );
        return ret;
    }
    
    
    /**
     * @return An integer equivalent to the ISO date+time input string.
     *
     * @see Convert#ISOdateToLong( String )		
     */
    public Object toDatabaseData( String value ) {
	long ret;

	try {
	    ret = Convert.ISOdateToLong( value );
	}
	catch( ParseException e ) {
	    // Hack!
	    ret = 0;
	}
	return new Long( ret );
    }


    /** @return The display data type */
    public Class getDataType() {
	return String.class;
    }


    /** @return The database data type */
    public Class getDatabaseType() {
	return Integer.class;
    }


    /** @return the display data type length */
    public int getDataTypeLength() {
	return( ISO_STRING_LENGTH );
    }
}
