package org.eso.ohs.core.dbb.client;

import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.ActionEvent;

import javax.swing.JFrame;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.TextDisplayWidget;

/**
 * Shows the DbbView table as text with an option to print it
 * <p>
 * $Id: DisplayTextAction.java,v 1.2 2005/02/11 10:31:49 tcanavan Exp $
 * <br>
 * @version $Revision: 1.2 $
 * @author D. Dorigo
 */

public class DisplayTextAction extends ActionSuperclass {

    private JFrame parentFrame_;
    private DbbView view_;
    private String appName_;
    private String title_;

    /**
     * constructor
     *
     * @param parentFrame       the parent frame
     * @param view              DbbView to be displayed
     * @param appName           name of the application using this dialog
     * @param title             title of this window
     */
    public DisplayTextAction(
            JFrame parentFrame,
            DbbView view,
            String appName,
            String title) {
        super(parentFrame, title);
        parentFrame_ = parentFrame;
        view_ = view;
        appName_ = appName;
        title_ = title;
    }

    /**
     * action starting method
     *
     * @param ev        user-initiated ActionEvent
     */
    public void actionPerformedImpl(ActionEvent ev) {
        Cursor currentCursor = parentFrame_.getCursor();
        parentFrame_.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        showText();
        parentFrame_.setCursor(currentCursor);
    }

    private void showText() {
        StringBuffer text = new StringBuffer();
        text.append("\n" + appName_);
        text.append("\nNumber of Rows: " + view_.getRows() + "\n\n");
        text.append(view_.printTable());

        TextDisplayWidget display =
            new TextDisplayWidget(title_, true, false, true);
        display.setCurrentPathAsLast();
        display.setTextArea(text.toString());
        display.setSize(new Dimension(600, 400));
        display.setVisible(true);
    }
}

