package org.eso.ohs.core.gui.utilities;


import java.awt.Font;

/**
 *  This is a simple class that contains a resourceString
 *  like CheckBox.font and the associated font. 
 */


public class FontResource {


    /**
     * The Swing resource that the font points to
     */

    private String resourceString_;

    /**
     * The font associated with the resiurce
     */

    private Font font_;

   
    /**
     * Constructor for font resource
     * @param resourceString The resource that the string refers to
     * @param font The font associated with the resource
     */


    public FontResource(String resourceString,Font font) {
        resourceString_ = resourceString;
        font_ = font;
    }

    /**
     * Geter for resource string.
     */


    public String getResource() {
        return resourceString_;
    }

    /**
     * Get the font associated with the resource string
     */

    public Font getFont() {
        return font_;
    }

}
