 
/* @(#) ImagePrint.java 1.1 99/01/11
 * Copyright (c) 1999 Lawrence Rodrigues
 */
package org.eso.ohs.core.gui.widgets.imageviewer;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.print.Printable;

/** Specifies methods for printing images drawn on a canvas
  * @version 1.0  1 No 1999
  * @author Larry Rodrigues
*/

public interface ImagePrint extends Printable {
   /** Sets the ULHC location at which the printing starts.
   * @param d  the ULHC location.
   */
   public void setPrintLocation(Point d);
   /** Returns the ULHC of the print location.
   * @return the print location
   */
   public Point getPrintLocation();
   /** Sets the size of the print.
   * @param d  the print size.
   */
   public void setPrintSize(Dimension d);
   /** Returns the print size.
   * @return the print size.
   */
   public Dimension getPrintSize();
   /**
   *Prints the image(s)drawn on the input graphics context.
   *@param g the graphics context over which images are drawn.
   */
   public void printImage(Graphics2D g);
}
