package org.eso.ohs.core.utilities;

import java.util.zip.CheckedInputStream;
import java.util.zip.CRC32;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;



public class CRC32Manager {

 private static void doChecksum(String fileName) {

     try {

         CheckedInputStream cis = null;
         long fileSize = 0;
         try {
             // Compute CRC32 checksum
             cis = new CheckedInputStream(
                     new FileInputStream(fileName), new CRC32());

             fileSize = new File(fileName).length();
             
         } catch (FileNotFoundException e) {
             System.err.println("File not found.");
             System.exit(1);
         }

         byte[] buf = new byte[128];
         while(cis.read(buf) >= 0) {
         }

         long checksum = cis.getChecksum().getValue();
         System.out.println("FileName: " + fileName + "\nCheckSum: " + checksum + "\nFileSize: " + fileSize);

     } catch (IOException e) {
         e.printStackTrace();
         System.exit(1);
     }


 }


 public static void main(String[] args) {
	 String path = "test/org/eso/ohs/phrs/viewpro/";
     String file = path + "xmlTest.xml";
	 
	 doChecksum(file);

 }

}

