package org.eso.ohs.core.utilities;

import java.util.EventListener;

/**
 * The interface that the JobAdaptor implements
 * The Adaptor which fires the events can choose which method 
 * it would like to implement i.e. which events will be fired
 * to the listeners
 * 
 * @author tcanavan
 */
public interface JobListener extends EventListener {
    
    /**
     * On Start 
     */
    public void onStarted();
    
    /**
     * On Finished
     */
    
    public void onFinished();
    
    /**
     * On Cancelled
     */
    
    
    public void onCanceled();
    
    /**
     * Retrun a message
     * @param message
     */
    
    public void onMessage(String message);
    
    /**
     * Return an exception
     * @param exception
     */
    
    public void onException(Exception exception);
    
    
    /**
     * Return out of Memory Error
     * @param exception
     */
    
    public void onOutOfMemory(OutOfMemoryError error);

    
    /**
     * Return in progress.
     * @param toProcess
     * @param processed
     */
    
    public void onProgress(int toProcess, int processed);


}
