/*
 * Created by amchavan on Sep 23, 2004
 */

package org.eso.ohs.core.utilities.cvsproxy;
import org.netbeans.lib.cvsclient.event.MessageEvent;

/**
 * A CVS console routing all CVS messages to a local string buffer.
 * <BR>
 * The buffer can be queried and cleared.
 * 
 * @version $Revision: 1.1 $
 * @author amchavan, 22-Sep-2004
 */

// $Id: StringCvsConsole.java,v 1.1 2004/09/23 09:48:38 amchavan Exp $

public class StringCvsConsole extends CvsConsole {

    private final StringBuffer messages = new StringBuffer();
    
    /**
     * Called when the server wants to send a message to be displayed to the
     * user. The message is only for information purposes and clients can
     * choose to ignore these messages if they wish.
     * 
     * @param e  The event
     */
    public void messageSent( MessageEvent e ) {
        String line = e.getMessage();

        if( e.isTagged() ) {
            String t = MessageEvent.parseTaggedMessage( taggedLineBuffer, line);
            // if we get back a non-null line, we have something
            // to output. Otherwise, there is more to come and we
            // should do nothing yet.
            if( t != null ) {
                messages.append( t );
                messages.append( '\n' );
            }
        }
        else if( line.length() > 0 ) {
            messages.append( line );
            messages.append( '\n' );
        }
    }
    
    /** Discard all contents of this console. */
    public void clear() {
        messages.delete( 0, messages.length()-1 );
    }
    
    /** @return The current contents of this console. */
    public String get() {
        return messages.toString();
    }
}