package org.eso.ohs.instruments;

/**
 * This is a factory class which creates the neccessary derived 
 * parameters depending on the parmeterType
 * <p>
 * $Id: CreateParam.java,v 1.4 2000/04/28 12:43:42 tcanavan Exp $
 * @author Tim Canavan
 */

public class CreateParam {  

    /**
     * Factory Creation method for parameter classes.
     */

    public CreateParam() {}
    static Parameter Create(ParamMetaData pMeta) throws NullPointerException {
        Parameter p = null;
        String parameterType = pMeta.getType();
        if(parameterType.equals("integer")) 
            p = new IntegerParameter(pMeta);                 
        else 
	if(parameterType.equals("coord")) 
            p = new CoordParameter(pMeta);              
        else
	if(parameterType.equals("number")) 
            p = new NumberParameter(pMeta);                
        else
        if(parameterType.equals("numlist"))
            p = new NumListParameter(pMeta);                
        else 
	if(parameterType.equals("intlist"))
            p = new IntListParameter(pMeta);                
        else
        if(parameterType.equals("intrect"))
            p = new IntRectParameter(pMeta);
        else
	  if(parameterType.equals("keyword"))
            p = new KeywordParameter(pMeta);
        else
        if(parameterType.equals("pixel"))
            p = new PixelParameter(pMeta);
        else
        if(parameterType.equals("string"))
            p = new StringParameter(pMeta);
        else
	if(parameterType.equals("keyword")) {
            p = new KeywordParameter(pMeta);
        }
        else
	if(parameterType.equals("keywordlist")) {
            p = new KeywordListParameter(pMeta);          
	}
        else
        if(parameterType.equals("boolean"))
            p = new BooleanParameter(pMeta);
        else
        if(parameterType.equals("file"))
            p = new FileParameter(pMeta);
        else
        if(parameterType.equals("filename"))
            p = new FilenameParameter(pMeta);    
        else
        if(parameterType.equals("paramfile"))
            p = new ParamFileParameter(pMeta);        
        return p;
    }         
}




