/*
 *
 * Copyright (C) 2000 European Southern Observatory 
 * License:  GNU General Public License version 2 or later
 */
package org.eso.ohs.persistence; 

import java.util.EventObject;


/** OBEvent defines an Observation Block event.
 *
 *  @version $Revision: 1.1 $  $Date: 2001/11/07 12:57:43 $
 *  @author  G.Passera, DMD/ESO, <gpassera@eso.org>
 */
public class OBEvent extends EventObject {

  
    private long[]  obsId;
    private String  property;
    private String value;
    

    /* Default constructor. */
    public OBEvent(Object source, long[] newOBsId, String newProperty,String value) {
	super(source);
	obsId = newOBsId;
	property = newProperty;
        this.value  = value;
    }

    public String getValue() {
        return value; 
    }


    /** Gets obId*/
    public long[] getOBsId(){
	return obsId;
    }

    /** Gets Property*/
    public String getProperty(){
	return property;
    }
}


