package org.eso.ohs.phase2.actions;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;
import javax.swing.JOptionPane;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.TextDisplayWidget;
import org.eso.ohs.core.utilities.ObjUtils;
import org.eso.ohs.persistence.ObjectContainer;

/**
 * 
 * Action class to display the contents of a readme file over time It displays
 * the current readme file at the top and the each of the changes to the readme
 * file at the bottom of the file.
 * <p>
 * $Id: ReadmeHistoryAction.java,v 1.4 2005/02/11 10:31:49 tcanavan Exp $<br>
 * 
 * @author Bob Kemp
 */

public class ReadmeHistoryAction extends ActionSuperclass {

    private static final int ID_PADDING = 8;

    private static final int OB_NAME_PADDING = 26;

    private static TextDisplayWidget fileMenu_ = new TextDisplayWidget(
            "OB Report");

    protected ObjectContainer folderView_;

    protected boolean folder_;

    /**
     * Constructs a ShowDetailsAction action.
     */
    public ReadmeHistoryAction(ObjectContainer folderView, boolean folder,
            String name) {
        super((JComponent) folderView, name);

        folderView_ = folderView;
        folder_ = folder;
        //fileMenu_.setVisible(false);
    }

    /**
     * Event handler for the ShowDetailsAction action.
     * 
     * @param ev
     *            user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
        Long[] idLongs = null;
        if (!folder_)
            idLongs = folderView_.getAllSelected();
        else
            idLongs = folderView_.getAll();
        idLongs = (Long[]) ObjUtils.uniqueOccurrences(idLongs);
        if (idLongs.length <= 0) {
            JOptionPane
                    .showMessageDialog(
                            folderView_.getTopLevelAncestor(),
                            new Object[] {
                                    "There are no selected business objects",
                                    " ",
                                    "You must first select business objects to report on." },
                            "Nothing selected", JOptionPane.ERROR_MESSAGE);
            return;
        }

    }
}

