package org.eso.ohs.phase2.apps.masktracker;

import org.eso.ohs.core.dbb.client.DbbDataType;
import org.eso.ohs.core.utilities.AssocList;
import org.eso.ohs.dfs.CalibrationBlock;

public class OBStatusType implements DbbDataType {

    private static AssocList valList_ = null;
    private final static String DEFAULT_ = "-----------";

    private static void init() {
	if(valList_ == null)
	    valList_ = CalibrationBlock.getStatusValues(); 
    }

    public static String[] getDatabaseValues() {
	init();
	return valList_.valuesAsStrings();
    }

    public static String[] getDisplayValues() {
	init();
	return valList_.keys();
    }

    public int getDataTypeLength() {
	return DEFAULT_.length();
    }
    
    public Class getDataType() {
	return String.class;
    }
    
    public Class getDatabaseType() {
	return String.class;
    }
    
    public String fromDatabaseData(Object value) {
	init();
	String ret = "";
	String[] databaseValues_ = valList_.valuesAsStrings();
	String[] displayValues_ = valList_.keys();

	for(int i=0; i<databaseValues_.length; i++) {
	    if(databaseValues_[i].equals(value)) {
		ret = displayValues_[i];
		break;
	    }
	}

	return ret;
    }
    
    public Object toDatabaseData(String value) {
	init();	
	return valList_.valueFor(value);
    }
}
